import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;

public class RolloverHotspot extends Applet
{
	protected Image message, image;
	protected Vector rects;
	protected MediaTracker tracker;
	int count = 0;
	int loadmap = 1;

	public void init()
	{
		rects = new Vector();
		Rollover r;
		tracker = new MediaTracker(this);

		this.showStatus("Loading message...");
		message = this.getImage(this.getDocumentBase(), this.getParameter("lowsrc"));
		tracker.addImage(message, 1);
		try {
			tracker.waitForID(1);
		} catch (InterruptedException e) {;}

	}

	public void loadMap()
	{
		rects = new Vector();
		Rollover r;
		tracker = new MediaTracker(this);


        int c=2;

		this.showStatus("Loading image...");
		image = this.getImage(this.getDocumentBase(), this.getParameter("src"));
		tracker.addImage(image, c++);


		int i=0;

		this.showStatus("Loading rollovers...");

		while ((r = getRectangleParameter("roll" + i)) != null)
		{
			rects.addElement(r);
			tracker.addImage(r.image, c++);
			i++;
		}

        for (i=2;i<c;i++) {
            this.showStatus("Preparing map... please wait");
    		try {
    			tracker.waitForID(i);
    		} catch (InterruptedException e) {;}
    		if (tracker.isErrorID(i)) this.showStatus("Error loading image "+i);
        }
        this.count++;
        this.showStatus("Map ready for use");
	}


	public void destroy()
	{
		image.flush();
	}

	public void paint(Graphics g)
	{
		if (count == 0) {
			g.drawImage(message, 0, 0, this);
			if (loadmap==1) this.loadMap();
			paint(g);
		}
		else
 			g.drawImage(image, 0, 0, this);

	}

	public void update(Graphics g)
	{
		paint(g);
	}

	private Rollover findrect(int x, int y)
	{
		int i;
		Rollover r=null;
		for (i=0; i<rects.size(); i++)
		{
			r = (Rollover) rects.elementAt(i);
			if (r.inside(x,y)) break;
		}

		if (i < rects.size()) return r;
		else return null;
	}

	private Rollover lastrect;

	public boolean mouseMove(Event e, int x, int y)
	{
		Rollover r=findrect(x,y);

		if (r==null && lastrect != null)
		{
			Graphics g=this.getGraphics();
			paint(g);
			lastrect = null;
			this.showStatus("Not on a hotlink...");
		}

		if (r != null && r != lastrect)
		{
			Graphics g=this.getGraphics();
			paint(g);
			g.drawImage(r.image, r.x, r.y, this);
			
			this.showStatus("Click on the highlighted link");
			lastrect = r;
		}

		return true;
	}


	public boolean mouseDown(Event e, int x, int y)
	{
		Rollover r=findrect(x,y);
	    	URL anchor;

        	try {
        		anchor = new URL(r.url);

       		}
		catch (MalformedURLException exc)
		{
			anchor = null;
			return false;
		}
                  catch (NullPointerException exc)
		{
			anchor = null;
			return false;
		}


        this.getAppletContext().showDocument(anchor);
		this.loadmap = 0;
		this.stop();

		return true;
	}


	protected Rollover getRectangleParameter(String name)
	{
		int x, y , w, h;
		String url;
		String alt;
		Image rollpic;

		String value= this.getParameter(name);
		if (value==null) return null;

		try {
			StringTokenizer st = new StringTokenizer(value, ",");
			x = Integer.parseInt(st.nextToken());
			y = Integer.parseInt(st.nextToken());
			w = Integer.parseInt(st.nextToken());
			h = Integer.parseInt(st.nextToken());
			url = st.nextToken();
			alt = st.nextToken();
		}
		catch (NoSuchElementException e) { return null; }
		catch (NumberFormatException e) { return null; }

		rollpic = this.getImage(this.getDocumentBase(), alt);

		return new Rollover(x, y, w, h, url, rollpic);
	}
}


class Rollover extends Rectangle
{
	String url;
	Image image;

	public Rollover(int x, int y, int w, int h, String url, Image image)
	{
		super(x, y, w, h);
		this.url = url;
		this.image = image;
	}
}